// esempio di agente

import java.io.* ;
import Agent.* ;

public class TestAgent extends Agent {
  protected String host ;
  protected int port ;
  // dati di prova che saranno spediti insieme all'agente
  protected String s1 ;
  protected int n1 ;
  
  public TestAgent( String s, int p ) {
    super( "Test" ) ;
    host = s ;
    port = p ;
  }
  
  protected void execute() throws AgentException {
    System.out.println( "Salve io l'agente " + AgentName() ) ;
    s1 = new String( "Stringa di prova" ) ;
    n1 = 100 ;
    System.out.println( "Queste sono due mie variabili : " +
      s1 + ", " + n1 ) ;
    System.out.println( "Adesso migro su " + host + ":" + port ) ;
    migrate( host, port ) ;
    System.out.println( "Agente migrato" ) ;
  }
  
  public void onArrival() throws AgentException {
    System.out.println( "Salve, sono l'agente " + AgentName() + 
      " appena arrivato..." ) ;
    System.out.println( "Queste sono due mie variabili : " +
      s1 + ", " + n1 ) ;
  }
  
  public static void main( String args[] ) {
    String host ;
    int port ;
    if ( args.length == 2 ) {
      host = args[0] ;
      port = Integer.parseInt( args[1] ) ;
    } else {
      host = new String ("localhost") ;
      port = 9999 ;
    }
    (new TestAgent( host, port )).start() ;
  }
}